#ifndef _HAL_H_
#define _HAL_H_

#include "config.h"
#include "main.h"
#include <avr/interrupt.h>

#define IN	0
#define OUT	1

#define HI_PART(a) (a>>3)
#define LO_PART(a) (a&7)

//
#define BAUD 115200
//#define BAUD 57600

void debug_init();
void debug(u8 val);
void debug_bit(u8 bit, u8 val);


//class Hal
//{
//public:
  //Hal();
  void digitalOut(u8 pin, u8 val);
  void digitalSet(u8 pin);
  void digitalClear(u8 pin);
  u8 digitalIn(u8 pin);
  void pinMode(u8 pin, u8 mode);
  u8 pinMode(u8 pin);
  void delay(u16 s);
  void delay_ms(u16 ms);
  void delay_us(u16 us);

  u16 strlen2(const u8 *buf);
  //u8 strlen(const u8 *str);
  u16 strlen2(const char *str);
  // { return strlen((const u8*)str); };

//#ifdef WANT_adc
  u16 analogIn(u8 pin);
//#endif

//#ifdef WANT_uart
  void uart(u32 bps);
  u8 uart_getc();
  void uart_putc(u8 ch);
  void uart_flush();
  //void do_uart();
  void uart_putdec(u16 data, u8 digits);
  void uart_putdec32(s32 data, u8 digits);
//#endif

//#ifdef WANT_timer0
  void timer0_init(u32 us);
  void timer0_start();
  void timer0_stop();
//#endif

//#ifdef WANT_timer1
  void timer1_init(u32 us);
  void timer1_start();
  void timer1_stop();
  void timer1_on_hz(u32 hz);
  void timer1_off_hz();
  // { TIMSK1 &= ~_BV(TOIE1); };
//#endif

//#ifdef WANT_timer2
  void timer2_init(u32 us);
  void timer2_start();
  void timer2_stop();
  void timer2_on_hz(u32 hz);
  void timer2_off_hz();
  // { TIMSK2 &= ~(1<<TOIE2); };
//#endif

//#ifdef WANT_puts
  void uart_puts(const u8 *str);
  void uart_puts(const char *str);
  // { uart_puts((u8*)str); };
//#endif

  s16 str2hex(const u8 *inp, u8 cnt);
  s16 str2dec(const u8 *inp, u8 cnt);
  s32 str2dec32(const u8 *inp, u8 cnt);
  s8 hexdigit(u8 inp);
  void uart_putNibble(u8 a);
  void uart_puthex16(u16 hex);

//private:
//};

#define MAX_CMD 32
extern u8 uart_buf[MAX_CMD];
//extern Hal hal;

void parse_buf();
void timer0_callback();
void timer1_callback();
void timer2_callback();

s32 abs(s32 a);
s16 abs(s16 a);
s8 abs(s8 a);

#endif //_HAL_H_
