//  #include <stdio.h>
//#include <stdlib.h>
//  #include <string.h>
//#include <math.h>
#include "main.h"
#include <util/delay_basic.h>
#include "hal.h"

#include <avr/interrupt.h>

static inline u8 RecodePin(u8 pin)
{
#ifndef WANT_recode_pins
  return pin;
#else
#if 1
  const u8 _A = 14;
  switch (pin)
  {
    case 8:  return 0x0;
    case 9:  return 0x1;
    case 10: return 0x2;
    case 11: return 0x3;
    case 12: return 0x4;
    case 13: return 0x5;

    case _A+0: return 0x8;
    case _A+1: return 0x9;
    case _A+2: return 0xA;
    case _A+3: return 0xB;
    case _A+4: return 0xC;
    case _A+5: return 0xD;
    //case _A+6: return 0xE;
    //case _A+7: return 0xF;

    case  2: return 0x12;
    case  3: return 0x13;
    case  4: return 0x14;
    case  5: return 0x15;
    case  6: return 0x16;
    case  7: return 0x17;

    default: return 0xFF;
  };
  return 0xFF;
#endif
#if 0
  // B 0..5 =6
  // C 0..5 =6
  // D 0..7 =8
  // adc =c0..6, adc7, adc6 =+2
  //xtal2, vcc2, gnd3, reset1, avcc, agnd = 10
  // 6+6+8+2+10=32
  if(pin < 6)
    return pin; // B <= 0..5
  if(pin < 6+6 ) // 6+6=0xc
    return pin +2; // C <= 6..12
  if(pin < 6+6+8 ) // 6+6+6=0x14
    return pin +4; // D <= 13..19,    
//#endif
//#endif //WANT_recode_pins
//#else
  //return pin+4;
#endif //0
#endif //WANT_recode_pins

}

/////////////////////////////////////////////////////////////////////////
/*
befor= pin = after
old  =     = old
tr   =     = tr
0x00 = D8  = 0x0
0x01 = D9  = 0x1
0x02 = D10 = 0x2
0x03 = D11 = 0x3
0x04 = D12 = 0x4
0x05 = D13 = 0x5
0x06 = A0  = 0x8
0x07 = A1  = 0x9
0x08 = A2  = 0xA
0x09 = A3  = 0xB
0x0A = A4  = 0xC
0x0B = A5  = 0xD
0x0E = D2  = 0x12
0x0F = D3  = 0x13
0x10 = D4  = 0x14
0x11 = D5  = 0x15
0x12 = D6  = 0x16
0x13 = D7  = 0x17
none = A6
none = A7
*/
/////////////////////////////////////////////////////////////////////////

//Hal hal;

//Hal::Hal()
//{
//}

void digitalOut(u8 pin, u8 val)
{
  if( (val & 1 ) == 0)
    digitalClear(pin);
  else
    digitalSet(pin);
}

void digitalSet(u8 pin)
{
  pin = RecodePin(pin);
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: PORTA |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: PORTB |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: PORTC |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: PORTD |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: PORTE |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: PORTF |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: PORTG |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: PORTH |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: PORTJ |= (u8)_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: PORTK |= (u8)_BV(LO_PART(pin)); return;
#endif
    default: return;
  }
}

void digitalClear(u8 pin)
{
  pin = RecodePin(pin);
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: PORTA &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: PORTB &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: PORTC &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: PORTD &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: PORTE &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: PORTF &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: PORTG &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: PORTH &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: PORTJ &= (u8)~_BV(LO_PART(pin)); return;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: PORTK &= (u8)~_BV(LO_PART(pin)); return;
#endif
    default: return;
  }
}

u8 digitalIn(u8 pin)
{
  pin = RecodePin(pin);
  u8 ret=0;
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: ret=PINA; break;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: ret=PINB; break;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: ret=PINC; break;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: ret=PIND; break;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: ret=PINE; break;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: ret=PINF; break;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: ret=PING; break;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: ret=PINH; break;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: ret=PINJ; break;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: ret=PINK; break;
#endif
    default: ret=0;
  }
  ret = (u8)(ret >> LO_PART(pin));
  return ret & 1;
}

void delay(u16 s)
{
  for(u16 i=0; i<s; i++)
  {
    delay_ms(1000);
  }
}

void delay_ms(u16 ms)
{
  for(u16 i=0; i<ms; i++)
  {
    delay_us(1000);
  }
}

void delay_us(u16 us)
{
  //_delay_loop_2() //4 cycles
  us = (u16)( ((u32)us * F_CPU) / 1000000L );
  _delay_loop_2(us);
}

void pinMode(u8 pin, u8 mode)
{
  pin = RecodePin(pin);
  u8 data=0;
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: data=DDRA; break;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: data=DDRB; break;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: data=DDRC; break;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: data=DDRD; break;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: data=DDRE; break;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: data=DDRF; break;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: data=DDRG; break;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: data=DDRH; break;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: data=DDRJ; break;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: data=DDRK; break;
#endif
    default: data=0;
  }
  if((mode & 1 )==0)
    data &= (u8)(~(1 << LO_PART(pin)));
  else
    data |= (u8)(1 << LO_PART(pin));
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: DDRA=data; break;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: DDRB=data; break;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: DDRC=data; break;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: DDRD=data; break;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: DDRE=data; break;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: DDRF=data; break;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: DDRG=data; break;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: DDRH=data; break;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: DDRJ=data; break;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: DDRK=data; break;
#endif
    default: return;
  }
}

u8 pinMode(u8 pin)
{
  pin = RecodePin(pin);
  u8 ret=0;
  switch(HI_PART(pin))
  {
#ifdef HAVE_PORTA
    case ENUM_PORT0: ret=DDRA; break;
#endif
#ifdef HAVE_PORTB
    case ENUM_PORT1: ret=DDRB; break;
#endif
#ifdef HAVE_PORTC
    case ENUM_PORT2: ret=DDRC; break;
#endif
#ifdef HAVE_PORTD
    case ENUM_PORT3: ret=DDRD; break;
#endif
#ifdef HAVE_PORTE
    case ENUM_PORT4: ret=DDRE; break;
#endif
#ifdef HAVE_PORTF
    case ENUM_PORT5: ret=DDRF; break;
#endif
#ifdef HAVE_PORTG
    case ENUM_PORT6: ret=DDRG; break;
#endif
#ifdef HAVE_PORTH
    case ENUM_PORT7: ret=DDRH; break;
#endif
#ifdef HAVE_PORTJ
    case ENUM_PORT8: ret=DDRJ; break;
#endif
#ifdef HAVE_PORTK
    case ENUM_PORT9: ret=DDRK; break;
#endif
    default: ret=0;
  }
  ret = (u8)(ret >> LO_PART(pin));
  return ret & 1;
}

#ifdef WANT_uart
void uart(u32 bps)
{
  uint16_t baud_setting;
  bool use_u2x;
  // U2X mode is needed for baud rates higher than (CPU Hz / 16)
  if ((unsigned long)bps > F_CPU / 16) 
  {
    use_u2x = true;
  } 
  else 
  {
    // figure out if U2X mode would allow for a better connection
    // calculate the percent difference between the baud-rate specified and
    // the real baud rate for both U2X and non-U2X mode (0-255 error percent)
    uint8_t nonu2x_baud_error = 
      (u8)abs((int)(255-((F_CPU/(16*(((F_CPU/8/bps-1)/2)+1))*255)/bps)));
    uint8_t u2x_baud_error = 
      (u8)abs((int)(255-((F_CPU/(8*(((F_CPU/4/bps-1)/2)+1))*255)/bps)));
    // prefer non-U2X mode because it handles clock skew better
    use_u2x = (nonu2x_baud_error > u2x_baud_error);
  }
  if (use_u2x) 
  {
    //*_ucsra = 1 << _u2x;
    UCSR0A = 1 << U2X0;
    baud_setting = (u16)((F_CPU / 4 / bps - 1) / 2);
  } else 
  {
    //*_ucsra = 0;
    UCSR0A = 0;
    baud_setting = (u16)((F_CPU / 8 / bps - 1) / 2);
  }
  // assign the baud_setting, a.k.a. ubbr (USART Baud Rate Register)
  UBRR0H = (u8)(baud_setting >> 8);
  UBRR0L = (u8)(baud_setting);
  UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0); // enable
}

//static 
u8 uart_getc()
{
  while( !(UCSR0A & (1<<RXC0)) ){};
  return UDR0;
}

//u8 uart_getc()
//{
//  return _uart_getc();
//}

//static 
void uart_putc(u8 ch)
{
  while ( !(UCSR0A & (1<<UDRE0)) ){};
  UDR0 = ch;
}

//void uart_putc(u8 ch)
//{
//  _uart_putc(ch);
//}

void uart_flush()
{
  u8 dummy;
  while ( UCSR0A & (1<<RXC0)) dummy = UDR0;
  (void)(dummy);
};

////////////////
u8 uart_buf[MAX_CMD];
u8 pos=0;

SIGNAL(USART_RX_vect)
{
  u8 i;
  i = uart_getc();
  uart_buf[pos] = i;

  if( ((i==0x0D)||(i==0x0A)||(i==0x00))
      &&(pos==0))
    return;
  
  //if(    (((i==0x0D)||(i==0x0A)||(i==0x00)||(i==' '))&&(pos>0))
  if(    (((i==0x0D)||(i==0x0A)||(i==0x00))&&(pos>0))
      || (pos>MAX_CMD-2))
  {
    uart_buf[pos]=0;
    parse_buf();
    pos=0;
  }
  else
    pos++;
}

#endif //WANT_uart

#define RESOLUTION 65536

#ifdef WANT_timer0

#if 0
void timer0_init(u32 us)
{
}

void timer0_start()
{
}

void timer0_stop()
{
}
#endif

#endif //WANT_timer0


#ifdef WANT_timer1

void timer1_on_hz(u32 hz)
{
  if(hz==0)
  {
    timer1_off_hz();
    return;
  }

  u8 clockSelectBits;

  TCCR1A = 0;                 // clear control register A.
  TCCR1B = _BV(WGM13);

  //u32 cycles = (F_CPU / 2000000)* us;
  u32 cycles = (F_CPU/2) / hz;
  // the counter runs backwards after TOP,
  // interrupt is at BOTTOM so divide microseconds by 2
  if(cycles < RESOLUTION)
    clockSelectBits = _BV(CS10);              // no prescale, full xtal
  else if((cycles >>= 3) < RESOLUTION) 
    clockSelectBits = _BV(CS11);              // prescale by /8
  else if((cycles >>= 3) < RESOLUTION) 
    clockSelectBits = _BV(CS11) | _BV(CS10);  // prescale by /64
  else if((cycles >>= 2) < RESOLUTION) 
    clockSelectBits = _BV(CS12);              // prescale by /256
  else if((cycles >>= 2) < RESOLUTION) 
    clockSelectBits = _BV(CS12) | _BV(CS10);  // prescale by /1024
  else
  {
    cycles = RESOLUTION - 1;
    clockSelectBits = _BV(CS12) | _BV(CS10);
  }
    // request was out of bounds, set as maximum

  ICR1 = (u16)cycles;    // ICR1 is TOP in p & f correct pwm mode
  
  TCCR1B &= (u8)(~(_BV(CS10) | _BV(CS11) | _BV(CS12)));
  TCCR1B |= clockSelectBits;
  // reset clock select register, and starts the clock
  TIMSK1 |= _BV(TOIE1);        // AR added.
}


void timer1_init(u32 us)
{
  u8 clockSelectBits;
  //u8 oldSREG;

  TCCR1A = 0;                 // clear control register A.
  TCCR1B = _BV(WGM13);

  u32 cycles = (F_CPU / 2000000)* us;
  // the counter runs backwards after TOP, interrupt is at BOTTOM so 
  // divide microseconds by 2

  if(cycles < RESOLUTION)
    clockSelectBits = _BV(CS10);              // no prescale, full xtal
  else if((cycles >>= 3) < RESOLUTION) 
    clockSelectBits = _BV(CS11);              // prescale by /8
  else if((cycles >>= 3) < RESOLUTION) 
    clockSelectBits = _BV(CS11) | _BV(CS10);  // prescale by /64
  else if((cycles >>= 2) < RESOLUTION) 
    clockSelectBits = _BV(CS12);              // prescale by /256
  else if((cycles >>= 2) < RESOLUTION) 
    clockSelectBits = _BV(CS12) | _BV(CS10);  // prescale by /1024
  else
  {
    cycles = RESOLUTION - 1;
    clockSelectBits = _BV(CS12) | _BV(CS10);
  }
    // request was out of bounds, set as maximum
  
  //oldSREG = SREG;
  //cli();			// Disable interrupts for 16 bit register access
  //ICR1 = pwmPeriod = cycles;    // ICR1 is TOP in p & f correct pwm mode
  ICR1 = (u16)cycles;    // ICR1 is TOP in p & f correct pwm mode
  //SREG = oldSREG;
  
  TCCR1B &= (u8)(~(_BV(CS10) | _BV(CS11) | _BV(CS12)));
  TCCR1B |= clockSelectBits;                                          
  // reset clock select register, and starts the clock
}

void timer1_start()
{
  TIMSK1 |= _BV(TOIE1);        // AR added.
}

void timer1_stop()
{
  TIMSK1 &= (u8)(~_BV(TOIE1));        // AR added.
  //TCCR1B &= ~(_BV(CS10) | _BV(CS11) | _BV(CS12)); //??
}

ISR(TIMER1_OVF_vect)
{
  timer1_callback();
}
#endif //timer1

#ifdef WANT_timer2
static volatile u32 MsTimer2_msecs;
static volatile u32 MsTimer2_count;
static volatile u16 MsTimer2_tcnt2;

void timer2_on_hz(u32 hz)
{
  if(hz==0)
  {
    timer2_off_hz();
    return;
  }

  u32 divider = F_CPU / hz;
  u8 limit=255;
  if(divider<256)
  {
    TCCR2B=(1<<CS20);
    limit=(u8)divider;
  }
  else if(divider<256L*8)
  {
    TCCR2B=(1<<CS21);
    limit=(u8)(divider/8L);
  }
  else if(divider<256L*32L)
  {
    TCCR2B=(1<<CS20)|(1<<CS21);
    limit=(u8)(divider/32L);
  }
  else if(divider<256L*64L)
  {
    TCCR2B=(1<<CS22);
    limit=(u8)(divider/64L);
  }
  else if(divider<256L*128L)
  {
    TCCR2B=(1<<CS22)|(1<<CS20);
    limit=(u8)(divider/128L);
  }
  else if(divider<256L*256L)
  {
    TCCR2B=(1<<CS22)|(1<<CS21);
    limit=(u8)(divider/256L);
  }
  else if(divider<256L*1024L)
  {
    TCCR2B=(1<<CS22)|(1<<CS21)|(1<<CS20);
    limit=(u8)(divider/1024L);
  }
  else
  {
    TCCR2B=(1<<CS22)|(1<<CS21)|(1<<CS20);
    limit=255;
  }
  //TIMSK2 &= ~(1<<TOIE2);
  //TCCR2A &= ~((1<<WGM21) | (1<<WGM20));
  //TCCR2B &= ~(1<<WGM22);
  ASSR &= (u8)(~(1<<AS2));
  TCCR2A |= (1<<WGM21); //WGM22:0=2 -> CTC mode
  OCR2A=limit;
  //TIMSK2 &= ~(1<<OCIE2A);
  TIMSK2 |= (1 << OCIE2A);
  //Set interrupt on compare match
}

void timer2_init(u32 us)//fixme! Hz or ms?
{
  u32 prescaler = 0;

  TIMSK2 &= (u8)(~(1<<TOIE2));
  TCCR2A &= (u8)(~((1<<WGM21) | (1<<WGM20)));
  TCCR2B &= (u8)(~(1<<WGM22));
  ASSR &= (u8)(~(1<<AS2));
  TIMSK2 &= (u8)(~(1<<OCIE2A));

  if ((F_CPU >= 1000000UL) && (F_CPU <= 16000000UL)) 
  {	// prescaler set to 64
    TCCR2B |= (1<<CS22);
    TCCR2B &= (u8)(~((1<<CS21) | (1<<CS20)));
    prescaler = 64;
  } 
  else if (F_CPU < 1000000UL) 
  {	// prescaler set to 8
    TCCR2B |= (1<<CS21);
    TCCR2B &= (u8)(~((1<<CS22) | (1<<CS20)));
    prescaler = 8;
  } else 
  { // F_CPU > 16Mhz, prescaler set to 128
    TCCR2B |= ((1<<CS22) | (1<<CS20));
    TCCR2B &= (u8)(~(1<<CS21));
    prescaler = 128;
  }

  MsTimer2_tcnt2 = (u16)(256 - (F_CPU / 1000L / prescaler));

  if (us == 0)
    MsTimer2_msecs = 1;
  else
    MsTimer2_msecs = us;
}

void timer2_start()
{
  MsTimer2_count = 0;
  TCNT2 = (u8)MsTimer2_tcnt2;
  TIMSK2 |= (1<<TOIE2);
}

void timer2_stop()
{
  TIMSK2 &= (u8)(~(1<<TOIE2));
}

ISR (TIMER2_COMPA_vect)
{
  timer2_callback();
}

ISR(TIMER2_OVF_vect) 
{
  TCNT2 = (u8)MsTimer2_tcnt2;
  MsTimer2_count += 1;
  if (MsTimer2_count >= MsTimer2_msecs)
  {
    MsTimer2_count = 0;
    timer2_callback();
  }
}
#endif //timer2

#ifdef WANT_adc
u16 analogIn(u8 pin)
{
  return 0;
}
#endif

#ifdef WANT_puts
void uart_puts(const char *str)
{
  uart_puts((u8*)str);
};

void uart_puts(const u8 *str)
{
  u16 pos2=0;
  while((str[pos2]!=0)&&(pos2<0xFFFE))
  {
    uart_putc(str[pos2]);
    pos2++;
  }
  //uart_putc('\n');
}

#endif

s8 hexdigit(u8 inp)
{
  if((inp>='0')&&(inp<='9'))
    return (s8)((s8)inp - '0');
  if((inp>='a')&&(inp<='f'))
    return (s8)((s8)inp - 'a'+10);
  if((inp>='A')&&(inp<='F'))
    return (s8)((s8)inp - 'A'+10);
  return -1;
}

s16 str2hex(const u8 *inp, u8 cnt)
{
  s16 sum=0;
  s8 val=0;
  for(u8 num=0; num<cnt;num++)
  {
    val =  hexdigit(inp[num]);
    if(val < 0)
      return sum;
    sum = 0x10*sum + val;
  }
  return sum;
}

s16 str2dec(const u8 *inp, u8 cnt)
{
  s16 sum=0;
  s8 val=0;
  s16 sign=+1;
  u8 num=0;
  
  if(inp[0]=='-')
  {
    num++;
    sign=-1;
  }
  if(inp[0]=='+')
  {
    num++;
  }
  
  for(; num<cnt;num++)
  {
    val =  hexdigit(inp[num]);
    if((val < 0)||(val>9))
      return sum*sign;
    sum = 10*sum + val;
  }
  return sum*sign;
}

s32 str2dec32(const u8 *inp, u8 cnt)
{
  s32 sum=0;
  s8 val=0;
  u8 num=0;
  s32 sign=+1;
  if(inp[0]=='-')
  {
    num++;
    sign=-1;
  }
  if(inp[0]=='+')
  {
    num++;
  }
  for(; num<cnt;num++)
  {
    val =  hexdigit(inp[num]);
    if((val < 0)||(val>9))
      return sum*sign;
    sum = 10*sum + val;
  }
  return sum*sign;
}

#ifdef WANT_puts
void uart_putNibble(u8 a)
{
  a &= 0xF;
  if(a<10)
    uart_putc((u8)(a+'0'));
  else
    uart_putc((u8)(a-10+'A'));
}

void uart_puthex16(u16 hex)
{
  u8 tmp_hi = (u8)(hex >>8);
  u8 tmp_lo = (u8)hex;
  uart_putNibble((u8)(tmp_hi >> 4 ));
  uart_putNibble(tmp_hi);
  uart_putNibble((u8)(tmp_lo >> 4 ));
  uart_putNibble(tmp_lo);
}

void uart_putdec(u16 data, u8 digits)
{
  if(digits>5)
    digits=5;
  u8 tmp[6];
  tmp[digits]=0;
  for(s8 i=(s8)(digits-1); i>=0; i--)
  {
    tmp[i]= (u8)(data % 10 + '0');
    data = data / 10;
  }
  uart_puts(tmp);
}

void uart_putdec32(s32 data, u8 digits)
{
  if(digits>7)
    digits=7;
  u8 tmp[9];
  if(data<0)
  {
    tmp[0]='-';
    data=-data;
  }
  else
    tmp[0]='+';

  tmp[digits+1]=0;
  for(s8 i=(s8)digits; i>0; i--)
  {
    tmp[i]= (u8)(((s32)data % (s32)10) + '0');
    data = data / (s32)10;
  }
  uart_puts(tmp);
}
#endif //#ifdef WANT_puts

/*
u8 strlen(const u8 *str)
{
  u8 pos2=0;
  for(pos2=0;pos2<255;pos2++)
  {
    if(str[pos2]==0)
      return pos2;
  }
  return 255;
}
*/

u16 strlen2(const char *str)
{
  return strlen2((const u8*)str);
};

u16 strlen2(const u8 *buf)
{
  u16 ret=0;
  while((buf[ret]!=0)&&(ret<0xFFFE))
    ret++;

  return ret;
}

void timer1_off_hz() 
{
  TIMSK1 &= (u8)(~_BV(TOIE1));
};

void timer2_off_hz()
{
  TIMSK2 &= (u8)(~(1<<TOIE2));
};
