#include "main.h"
#include "hal.h"

#include "globals.h"
#include "xypt.h"

s32 abs(s32 a)
{
  if(a>0)
    return a;
  return -a;
}

s16 abs(s16 a)
{
  if(a>0)
    return a;
  return -a;
}

s8 abs(s8 a)
{
  if(a>0)
    return a;
  return (s8)-a;
}

u8 queue_is_full=0;

extern s32 motor1_curr;
extern s32 motor2_curr;
extern s32 motor1_need;
extern s32 motor2_need;

/*
u16 strlen(const u8 *buf)
{
  u16 ret=0;
  while((buf[ret]!=0)&&(ret<0xFFFE))
    ret++;

  return ret;
}
*/

extern volatile u16 servo_value;
extern u8 queue_count;

u8 stepmotor;

static s32 getted_T=1000;
static s32 getted_L=0;
static s32 getted_R=0;

static bool parse4(const u8 *buf)
{
  u8 pos[5];

  pos[4]=(u8)strlen2(buf);
  pos[0]=0;

  for(u8 num=1;num<4;num++)
  {
    pos[num]=pos[num-1];
    while( (buf[pos[num]]!=' ')&&(pos[num]<pos[4]))
    {
      pos[num]++;
    }
    pos[num]++;

    if(pos[num]>=pos[4])
    {
      uart_puts("ERROR x1\r\n");
      return false;
    }
  }
  pos[4]++;
  
  XYPT item;
  
  item.x = str2dec32(buf+pos[0], (u8)(pos[1]-pos[0]-1));
  item.y = str2dec32(buf+pos[1], (u8)(pos[2]-pos[1]-1));
  item.p = (u16)str2dec(buf+pos[2], (u8)(pos[3]-pos[2]-1));
  item.t = (u16)str2dec(buf+pos[3], (u8)(pos[4]-pos[3]-1));
  if(item.t == 0L)
  {
    uart_puts("ERROR x0\r\n");
    return false;
  }
  
  u8 a = queue_put(&item);

  {
    //uart_puts("X=");
    //uart_putdec32(item.x,7);
    //uart_puts("\r\nY=");
    //uart_putdec32(item.y,7);
    //uart_puts("\r\nP=");
    //uart_putdec(item.p,7);
    //uart_puts("\r\nT=");
    //uart_putdec(item.t,7);
    //uart_puts("\r\nQ=");
    //uart_putdec(queue_count,3);
    //uart_puts("\r\n");
  }
  
  if(a==QUEUE_FULL)
  {
    queue_is_full=1;
    uart_puts("OK-FULL\r\n");
    return false; //queue full
  }
  if(a >= QUEUE_GT_SUB_FULL)
  {
    queue_is_full=1;
    uart_puts("OK0\r\n");
    return true;
  }
  
  //half full
  {
    queue_is_full=0;
    uart_puts("OK1\r\n");
    return true;
  }
  
  //for(int num=0;num<4;num++)
  //{
    //printf("[%i]=%i:`%s`\n",num,pos[num],in+pos[num]);
    //int s_len=pos[num+1]-pos[num]-1;
    //s_print(in+pos[num],s_len);
    // 0 - motor1
    // 1 - motor2
    // 2 - servo
    // 3 - time
  //}
    uart_puts("OK\r\n");
  return true;
}

void parse_buf()
{
  //debug_bit(0,1);
  if((uart_buf[0]=='I')||(uart_buf[0]=='i'))
  {
    uart_puts("OK\r\n");
    return;
  }
  if((uart_buf[0]=='Z')||(uart_buf[0]=='z'))
  {
    u8 len = (u8)strlen2(uart_buf);
    u16 tmp = (u16)str2hex(uart_buf+1,len);
    uart_puts("OK\r\nZ=0x");
    //uart_putdec(tmp,3);
    uart_puthex16(tmp);
    uart_puts("\r\n");
    //debug(tmp);
    return;
  }
  if((uart_buf[0]=='?')||(uart_buf[0]=='H')||(uart_buf[0]=='h'))
  {
    uart_puts("S=");
    uart_putdec(servo_value,3);
    uart_puts("\r\nL=");
    uart_putdec32(motor1_curr,7);
    uart_puts(" of ");
    uart_putdec32(motor1_need,7);
    uart_puts("\r\nR=");
    uart_putdec32(motor2_curr,7);
    uart_puts(" of ");
    uart_putdec32(motor2_need,7);
    uart_puts("\r\nT=");
    uart_putdec32(getted_T,5);
    //uart_puts("\r\n");
    uart_puts("\r\nLe=");
    uart_putdec( digitalIn(6),1);
    uart_puts(" Re=");
    uart_putdec( digitalIn(7),1);
    uart_puts(" Xe=");
    uart_putdec( digitalIn(8),1);
    uart_puts("\r\n");
    uart_buf[0]=0;
    //debug_bit(0,0);
    return;
  }
  if((uart_buf[0]=='M')||(uart_buf[0]=='m')) //motor bits
  {
    u8 len = (u8)strlen2(uart_buf);
    s16 tmp = str2hex(uart_buf+1,len);
    if(tmp<0)
    {
      uart_puts("ERROR1\r\n");
      uart_buf[0]=0;
      //debug_bit(0,0);
      return;
    }
    if(tmp>255)
    {
      uart_puts("ERROR1\r\n");
      uart_buf[0]=0;
      //debug_bit(0,0);
      return;
    }
    
    stepmotor=(u8)tmp;
    for(u8 i=0;i<8;i++)
    {
      digitalOut((u8)(2+i), (u8)(tmp & 1));
      tmp = tmp >> 1;
    }
    uart_puts("OK ");
    uart_puthex16(stepmotor);
    uart_puts("\r\n");
    //debug_bit(0,0);
    return;
  }

  if((uart_buf[0]=='S')||(uart_buf[0]=='s')) //servo pos
  {
    u16 len = strlen2(uart_buf+1);
    s16 tmp = str2dec(uart_buf+1,(u8)len);
    if( (tmp>=20)&&(tmp<=140))
    {
      servo_value = (u16)tmp;
      uart_puts("OK\r\n");
      //uart_putdec(servo_value,3);
      //uart_puts("\r\n");
      uart_buf[0]=0;
      //debug_bit(0,0);
      return;
    }
    uart_puts("ERROR2\r\n");
    //debug_bit(0,0);
    return;
  }

  if((uart_buf[0]=='T')||(uart_buf[0]=='t')) // time
  {
    //getted_T
    u8 len = (u8)strlen2(uart_buf+1);
    s16 tmp = str2dec(uart_buf+1,len);
    if( (tmp>0)&&(tmp<=32000))
    {
      getted_T = (u16)tmp;
      uart_puts("OK\r\n");
      //uart_putdec(getted_T,5);
      //uart_puts(" ms\r\n");
      return;
    }
    uart_puts("ERROR3\r\n");
    //debug_bit(0,0);
    return;
  }
  if((uart_buf[0]=='L')||(uart_buf[0]=='l')) // left motor
  {
    u8 len = (u8)strlen2(uart_buf+1);
    s32 tmp = str2dec32(uart_buf+1,len);
    if( (tmp>-32000)&&(tmp<=32000))
    {
      getted_L = tmp;
      //uart_puts("OK\r\n");
      //uart_putdec32(getted_L,5);
      //uart_puts("\r\n");
      if(getted_T==0)
      {
        uart_puts("T=0!\r\n");
        //debug_bit(0,0);
        return;
      }

      {
        timer1_off_hz();
        motor1_need += getted_L;
        timer1_on_hz((u32)((abs(getted_L)*1000L)/getted_T));
      }

      //LLLLL
      //uart_puts("E_L OK\r\n");
      uart_puts("OK\r\n");
      //debug_bit(0,0);
      return;
    }
    uart_puts("ERROR4\r\n");
    //debug_bit(0,0);
    return;
  }
  if((uart_buf[0]=='R')||(uart_buf[0]=='r')) // right motor
  {
    u8 len = (u8)strlen2(uart_buf+1);
    s32 tmp = str2dec32(uart_buf+1,len);
    if( (tmp>-32000)&&(tmp<=32000))
    {
      getted_R = tmp;
      //uart_puts("OK\r\n");
      //uart_putdec32(getted_R,5);
      //uart_puts("\r\n");
      if(getted_T==0)
      {
        uart_puts("T=0!\r\n");
        //debug_bit(0,0);
        return;
      }
      {
        timer2_off_hz();
        motor2_need += getted_R;
        timer2_on_hz((u32)((abs(getted_R)*1000L)/getted_T));
      }
      //RRRRR
      uart_puts("OK\r\n");
      //debug_bit(0,0);
      return;
    }
    uart_puts("ERROR5\r\n");
    //debug_bit(0,0);
    return;
  }

  if((uart_buf[0]=='E')||(uart_buf[0]=='e'))
  {
    uart_puts("Le=");
    uart_putdec( digitalIn(6),1);
    uart_puts(" Re=");
    uart_putdec( digitalIn(7),1);
    uart_puts(" Xe=");
    uart_putdec( digitalIn(8),1);
    uart_puts("\r\n");
    return;
  }

  if((uart_buf[0]=='A')||(uart_buf[0]=='a')) //zero curr,need
  {
    set_pos_zero();
    uart_puts("OK\r\n");
    return;
  }
  
  if(parse4(uart_buf))
  {
    //debug_bit(0,0);
    return;
  }
  uart_puts("ERROR6\r\n");
  uart_buf[0]=0;
  //debug_bit(0,0);
}

