#include "main.h"
#include "hal.h"

#include "globals.h"
#include "xypt.h"


XYPT queue[QUEUE_SIZE];
u8 queue_head=0;
u8 queue_tail=0;
u8 queue_count=0;

u8 queue_put(const XYPT *item)
{
  if(queue_count>QUEUE_SIZE-1)
    return QUEUE_FULL;

  queue[queue_head].x = item->x;
  queue[queue_head].y = item->y;
  queue[queue_head].p = item->p;
  queue[queue_head].t = item->t;
  
  queue_head++;
  queue_count++;
  if(queue_head==QUEUE_SIZE)
    queue_head=0;

  return queue_status();
}

bool queue_get(XYPT *ret)
{
  if(queue_count==0)
    return false;

  queue_count--;

  ret->x = queue[queue_tail].x;
  ret->y = queue[queue_tail].y;
  ret->p = queue[queue_tail].p;
  ret->t = queue[queue_tail].t;

  queue_tail++;
  if(queue_tail>=QUEUE_SIZE)
    queue_tail=0;

  return true;
}

/*
void queue_dump()
{
  printf("HEAD: %i, ",queue_head);
  printf("TAIL: %i, ",queue_tail);
  printf("COUNT: %i\n",queue_count);
  for(int i=0;i<QUEUE_SIZE;i++)
  {
    printf("%i: [ %i ]\n",i, queue[i]);
  }
}
*/

u8 queue_status()
{
  if ( queue_count > QUEUE_SIZE-1 )
    return QUEUE_FULL;

  if ( queue_count > QUEUE_SUB_FULL_SIZE)
    return QUEUE_GT_SUB_FULL;

  if ( queue_count >QUEUE_SUB_EMPTY_SIZE)
    return QUEUE_GT_SUB_EMPTY;

  if( queue_count !=0 )
    return QUEUE_LT_SUB_EMPTY;

  return QUEUE_EMPTY;
}
